#include <set>
#include <map>
#include <algorithm>
#include <cstring>
#include <string>
#include <iostream>
using namespace std;
long long licznik[6][6];
long long mianownik[6][6];
struct el {
  long long wartosc;
  int jednostka;
};

struct ltel {
inline bool operator()(const el &a1, const el &a2) {
  return (a1.wartosc * mianownik[a1.jednostka][a2.jednostka] >
    a2.wartosc * licznik[a1.jednostka][a2.jednostka]);
}
};

struct ltstr {
  bool operator()(char *a, char *b) {
    return strcmp(a, b) < 0;
  }
};

int obliczony[6][6] = { 0 };

long long NWD(long long a, long long b) {
  while (b != 0) {
    long long c = a % b;
    a = b;
    b = c;
  }

  return a;
}

int main() {
  ios_base::sync_with_stdio(false);
  int d;
  cin >> d;
  for (int i = 0; i < d; ++i) {
    int p;
    cin >> p;

    map<string, int> m;
    set<string> in;
    int ile = 0;

    for (int j = 0; j < p; ++j) {
      string j1, j2;
      int l1, l2;
      int przel;
      int tmp;
      char tt;
      cin >> tmp >> j1 >> tt >> przel >> j2;
      printf("1 %s = %d %s\n", j1.c_str(), przel, j2.c_str());
      if (in.find(j1) == in.end()) {
        in.insert(j1);
        l1 = ile;
        m[j1] = ile++;
      }
      else
        l1 = m[j1];

      if (in.find(j2) == in.end()) {
        in.insert(j2);
        l2 = ile;
        m[j2] = ile++;
      }
      else
        l2 = m[j2];

      printf("%d %d %d\n", l1, przel, l2);
      obliczony[l1][l2] = 1;
      licznik[l1][l2] = 1;
      mianownik[l1][l2] = przel;
    }
    for (int ii = 0; ii < ile; ++ii) {
      obliczony[ii][ii] = 1;
      licznik[ii][ii] = 1;
      mianownik[ii][ii] = 1;
    }

    fprintf(stderr, "Robie floyda\n");

    for (int ii = 0; ii < ile; ++ii)
      for (int j = 0; j < ile; ++j)
        for (int k = 0; k < ile; ++k) {
          if (obliczony[j][ii] && obliczony[ii][k]) {
            licznik[j][k] = licznik[j][ii] * licznik[ii][k];
            mianownik[j][k] = mianownik[j][ii] * mianownik[ii][k];

            long long nwd = NWD(licznik[j][k], mianownik[j][k]);
            licznik[j][k] /= nwd;
            mianownik[j][k] /= nwd; 

            licznik[k][j] = mianownik[j][k];
            mianownik[k][j] = licznik[j][k];
            obliczony[j][k] = obliczony[k][j] = 1;
          }
        }

    fprintf(stderr, "Floyd OK\n");

    int w;
    cin >> w;
    set <el, ltel > S;
    for (int ii = 0; ii < w; ++ii) {
      int wartosc;
      string jednostka;
      cin >> wartosc >> jednostka;
      int j = m[jednostka];

      el e;
      e.wartosc = wartosc;
      e.jednostka = j;
      S.insert(e);
    }
    int q;
    cin >> q;
    for (int ii = 0; ii < q; ++ii) {
      int wartosc;
      string jednostka;
      cin >> wartosc >> jednostka;
      int j = m[jednostka];

      el e;
      e.wartosc = wartosc;
      e.jednostka = j;
      set<el, ltel>::iterator f = S.find(e);
      if (f != S.end()) {
        printf("%lld %d\n", f->wartosc, f->jednostka);
      }
      else {
        set<el, ltel>::iterator ff;
        f = S.upper_bound(e);
        if (f != S.end())
        { ff = f; ++ff; }
        else
          ff = S.end();
        
        if (ff == S.end()) {
          printf("%lld %d\n", f->wartosc, f->jednostka);
        }
        else if (f == S.end()) {
          printf("%lld %d\n", ff->wartosc, ff->jednostka);
        }
        else {
          printf("bede sprawdzal\n");
        }

      }
    }
  }
}

