#include <algorithm>
#include <vector>
using namespace std;

struct przejazd;

struct node {
  long long przyjazd;
  node **pos_heap;
  vector<przejazd> przejazdy;
} nodes[60000];

struct przejazd {
  int cel;
  int dlugosc;
  int okres;
  int start;
  int bezp_czas;
};

node * heap[60000];
int in_heap[60000];
int finished[60000];
int num_heap;

void upheap(int);

void insert_heap(int i) {
  in_heap[i] = 1;
  heap[++num_heap] = &nodes[i];
  nodes[i].pos_heap = &heap[num_heap];
  upheap(num_heap);
}

inline int parent(int a) {
  return a / 2;
}

inline int lson(int a) {
  return 2 * a;
}
inline int rson(int a) {
  return 2 * a + 1;
}

void upheap(int a)
{
  if (a != 1) {
    if (heap[a]->przyjazd < heap[parent(a)]->przyjazd) {
      node *temp = heap[parent(a)];
      heap[parent(a)] = heap[a];
      heap[a] = temp;
      heap[a]->pos_heap = &heap[a];
      heap[parent(a)]->pos_heap = &heap[parent(a)];
      upheap (parent(a));
    }
  }
}

void downheap(int a) {
  node *max = heap[a];

  if (lson(a) <= num_heap && heap[lson(a)]->przyjazd < max->przyjazd)
    max = heap[lson(a)];
  if (rson(a) <= num_heap && heap[rson(a)]->przyjazd < max->przyjazd)
    max = heap[rson(a)];

  if (max != heap[a]) {
    node *temp = heap[a];
    heap[a] = max;
    if (max == heap[lson(a)]) {
      heap[lson(a)] = temp;
      heap[a]->pos_heap = &heap[a];
      heap[lson(a)]->pos_heap = &heap[lson(a)];
      downheap(lson(a));
    }
    else {
      heap[rson(a)] = temp;
      heap[a]->pos_heap = &heap[a];
      heap[rson(a)]->pos_heap = &heap[rson(a)];
      downheap(rson(a));
    }
  }
}

int heap_empty() {
  return (num_heap == 0);
}

int main() {
  int d;
  scanf ("%d", &d);

  for (int i = 0; i < d; ++i) {
    num_heap = 0;
    int n, m;
    scanf("%d%d", &n, &m);

    for (int j = 0; j < n; ++j) {
      in_heap[j] = 0;
      finished[j] = 0;
      nodes[j].przejazdy.clear();
    }

    for (int j = 0; j < m; ++j) {
      int u, v, w, t, a, l;

      scanf("%d%d%d%d%d%d", &u, &v, &w, &t, &a, &l);

      przejazd p;
      p.cel = v - 1;
      p.dlugosc = w;
      p.okres = t;
      p.start = a;
      p.bezp_czas = l;

      nodes[u - 1].przejazdy.push_back(p);
    }

    //printf("wczytalem dane\n");

    insert_heap(0);

    //printf("wstawilem\n");

    while (!heap_empty()) {
      node *cur = heap[1];
      //printf("%d ", cur - nodes);
      if (num_heap > 1) {
        heap[1] = heap[num_heap];
        heap[1]->pos_heap = &heap[1];
        --num_heap;
        downheap(1);
      }
      else
        --num_heap;
      finished[cur - nodes] = 1;
      long long czas = cur->przyjazd;
      //printf("%d ", czas);

      for (int j = 0; j < cur->przejazdy.size(); ++j) {
        przejazd &p = cur->przejazdy[j];
        //printf("DEBUG: %d %d %d %d %d\n", p.cel, p.dlugosc, p.okres,
        //  p.start, p.bezp_czas);
        long long bezpieczny_wyjazd;

        if (p.okres == 0 && p.start == 0 && p.bezp_czas == 0)
          bezpieczny_wyjazd = czas;
        else if (czas < p.start)
          bezpieczny_wyjazd = p.start;
        else if (((czas - p.start) % p.okres) < p.bezp_czas)
          bezpieczny_wyjazd = czas;
        else
          bezpieczny_wyjazd = czas - ((czas - p.start) % p.okres) + p.okres;

        //printf("%d\n", bezpieczny_wyjazd);

        long long przyjazd_do_celu = bezpieczny_wyjazd + p.dlugosc;

        if (!finished[p.cel]) {
          if (in_heap[p.cel]) {
            if (przyjazd_do_celu < nodes[p.cel].przyjazd) {
              nodes[p.cel].przyjazd = przyjazd_do_celu;
              upheap(nodes[p.cel].pos_heap - heap);
            }
          }
          else {
            in_heap[p.cel] = 1;
            nodes[p.cel].przyjazd = przyjazd_do_celu;
            insert_heap(p.cel);
          }
        }
      }
    }

    //printf("zrobilem\n");

    if (!finished[n - 1]) {
      printf("NIE\n");
    }
    else {
      printf("%lld\n", nodes[n - 1].przyjazd);
    }
  }

  return 0;
}

