#include <stdio.h>
#include <algorithm>
#include <deque>

using namespace std;

int n;
struct point {
	long double x;
	long double y;
} *P, *S;
int Sn;
point center;

long double rot(const point &a, point b, point c) {
	b.x -= a.x;
	b.y -= a.y;
	c.x -= a.x;
	c.y -= a.y;
	return b.x * c.y - b.y * c.x;
}


long double rot(const point &a, const point &b) {
	return rot(center, a, b);
}

bool compyx(const point &a, const point &b) {
	return a.y < b.y || a.y == b.y && a.x < b.x;
}

long double length(point a) {
	a.x -= center.x;
	a.y -= center.y;
	return a.x*a.x + a.y*a.y;
}

long double dist(point a, const point &b) {
	a.x -= b.x;
	a.y -= b.y;
	return a.x*a.x + a.y*a.y;
}


bool comp(const point &a, const point &b) {
	return rot(a, b) > 0 || rot(a, b) == 0 && length(a)<length(b);
}

void case_() {
	scanf("%i", &n);
	int x, y;
	for (int i = 0; i < n; ++i) {
		scanf("%i %i", &x, &y);
		P[i].x = x;
		P[i].y = y;
	}
	
	deque<point> D;
	D.push_front(P[1]);
	D.push_front(P[0]);
	D.push_front(P[1]);

	for (int i = 2; i < n; ++i) {
		while (true) {
			point a = D.front();
			D.pop_front();
			point b = D.front();
			if (rot(a, b, P[i]) >= 0) {
				D.push_front(a);
				break;
			}
		}
		D.push_front(P[i]);
		while (true) {
			point a = D.back();
			D.pop_back();
			point b = D.back();
			if (rot(a, b, P[i]) <= 0) {
				D.push_back(a);
				break;
			}
		}
		D.push_back(P[i]);
		//for (deque<point>::iterator i = D.begin(); i != D.end(); ++i) {
			//printf("%Lf %Lf\n", i->x, i->y);	
		//}
		//printf("----\n");
	}
	Sn = 0;
	for (deque<point>::iterator i = D.begin(); i != D.end(); ++i) {
		S[Sn++] = *i;
	}
	
/*	center = P[0];
	sort(P+1, P+n, comp);
	for (int i = 1; i < n; ++i) {
		if (compyx(P[i], P[0])) {
			swap(P[i], P[0]);
		}
	}
	center = P[0];
	sort (P, P+n, comp);
	S[0] = P[0];
	S[1] = P[1];
	Sn = 2;
	for (int i = 2; i < n; ++i) {
		while (Sn > 2 && rot(S[Sn-1], S[Sn-2], P[i])>0)
			Sn--;
		S[Sn++]=P[i];
	}*/
	
	/*for (int i = 0; i < Sn; ++i) {
		printf("%Lf %Lf\n", S[i].x, S[i].y);
	}*/
	int pos1 = 0, pos2 = 0;
	long double max_dist = 0;
	for (; pos1 < Sn; ++pos1) {
		while (dist(S[pos1], S[pos2]) < dist(S[pos1], S[(pos2+1)%Sn]))
			pos2 = (pos2+1)%Sn;
		max_dist = max(max_dist, dist(S[pos1], S[pos2]));
	}
	printf("%.0Lf\n", max_dist);
}

int main() {
	P = new point[512000];
	S = new point[512000];
	int d;
	scanf("%i", &d);
	for (int i = 0; i < d; ++i)
		case_();
}
