#include <stdio.h>
#include <list>

using namespace std;

struct point {
	long double x, y, z;
	void rev() {
		x = -x;
		y = -y;
		z = -z;
	}
	void dump() {
		printf("(%Lf %Lf %Lf)", x, y, z);
	}
};

point operator-(const point &a, const point &b) {
	point ret;
	ret.x = a.x - b.x;
	ret.y = a.y - b.y;
	ret.z = a.z - b.z;
	return ret;
}

long double dot(const point &a, const point &b) {
	long double ret = 0.0;
	ret += a.x * b.x;
	ret += a.y * b.y;
	ret += a.z * b.z;
	return ret;
}

point operator*(const point &a, const point &b) {
	point ret;
	ret.x = a.y * b.z - a.z * b.y;
	ret.y = a.z * b.x - a.x * b.z;
	ret.z = a.x * b.y - a.y * b.x;
	return ret;
}

struct plane {
	point T;
	point N;

	long double apply(const point &a) {
		return dot(a-T, N);
	}
	void dump() {
		return;
		printf("[T=");
		T.dump();
		printf(",");
		N.dump();
		printf("]\n");
	}



};

#define sciana planes
plane planes[200000];
int planes_c;
list<point> ex;

void czytaj_sciane(int which, bool make_ex) {
	int k;
	scanf("%i", &k);
	point P;
	point a, b, c;
	for (int i = 0; i < k; ++i) {
		scanf("%Lf %Lf %Lf", &P.x, &P.y, &P.z);
		if (make_ex) ex.push_back(P);
		if (i == 0) a = P;
		else if (i == 1) b = P;
		else if (i == 2) c = P;
	}
	planes[which].T = a;
	planes[which].N = (b - a) * (c - a);
}

void popraw_sciane(int which) {
	for (list<point>::iterator i = ex.begin(); i != ex.end(); ++i) {
		long double v;
		if ((v = sciana[which].apply(*i)) != 0) {
			if (v < 0) {
				sciana[which].N.rev();
				break;
			}
		}
	}
}

void case_() {
	ex.clear();
	int m;
	scanf("%i", &m);
	czytaj_sciane(0, 1);
	czytaj_sciane(1, 1);
	for (int i = 2; i < m; ++i) {
		czytaj_sciane(i, 0);
	}
	for (int i = 0; i < m; ++i) {
		popraw_sciane(i);
		sciana[i].dump();
	}
	int n;
	scanf("%i", &n);
	for (int i = 0; i < n; ++i) {
		point P;
		scanf("%Lf %Lf %Lf", &P.x, &P.y, &P.z);
		bool ok = true;
		for (int j = 0; j < m; ++j) {
			if (sciana[j].apply(P) < 0) {
				ok = false;
				break;
			}
		}
		if (ok) printf("TAK\n");
		else printf("NIE\n");
	}
	printf("\n");
}

int main() {
	int d;
	scanf("%i", &d);
	for (int i =0 ; i < d; ++i) {
		case_();
	}
	return 0;
}
