#include <stdio.h>

using namespace std;

struct point
{
 long long int x,y,z;
 bool operator==(point &b) {return x==b.x && y==b.y && z==b.z;}
 void operator-=(point &b) {x-=b.x; y-=b.y; z-=b.z;}
};

struct plane
{
 point norm;
 point trans;
 void Create(point &N, point &T) {norm=N; trans=T;};
 void reverse() {norm.x=-norm.x; norm.y=-norm.y; norm.z=-norm.z;}
};

int LS; //Liczba Scian

point wierzcholki[10001];
point base[20001];
plane sciana[200001];
int baseend;
int lastplane;


bool IsOver(point &p, plane &pi)
{
 return pi.norm.x*(p.x-pi.trans.x)+pi.norm.y*(p.y-pi.trans.y)+pi.norm.z*(p.z-pi.trans.z)>0;
}

bool exterior(point &p)
{
 for (int i=0; i<LS; ++i)
 {
  if (IsOver(p,sciana[i])) return true;
 }
 return false;
}


bool Find(point &what, point where[], int wheresize)
{
 for (int i=0; i<wheresize; ++i)
  {
	if (where[i]==what)
		return true;
  }
 return false;
}

point& Ofplane(point TW[], int LW)
{
 int i=0;
 while (true)
  {
   if (!Find(base[i],TW,LW))
     return base[i];
   ++i;
  }
}

void Add(point TW[], int LW)
{
 point Norm;
 TW[1]-=TW[0];
 TW[2]-=TW[0];
 Norm.x=TW[1].y*TW[2].z-TW[2].y*TW[1].z;
 Norm.y=TW[1].z*TW[2].x-TW[2].z*TW[1].x;
 Norm.z=TW[1].x*TW[2].y-TW[2].x*TW[1].y;
 point Trans=TW[0];
 point PP=Ofplane(TW, LW);
 sciana[lastplane].Create(Norm,Trans);
 if (IsOver(PP,sciana[lastplane])) sciana[lastplane].reverse();
 ++lastplane;
}

void con(point w[], int wsize)
{
 for (int i=0; i<wsize; ++i)
  {
   base[baseend++]=w[i];
  }
}

int main()
{
 int LZestaw;
 scanf("%d",&LZestaw);
 while (LZestaw--)
 {
  baseend=0;
  lastplane=0;
  int LfirstW;
  scanf("%d",&LS);
  int LW; //Liczba Wierzcholkow
  for (int i=0; i<LS; ++i)
  {
   scanf("%d",&LW);
   for (int j=0; j<LW; ++j)
    scanf("%Ld%Ld%Ld",&wierzcholki[j].x,&wierzcholki[j].y,&wierzcholki[j].z);
   if (i>1)
	Add(wierzcholki,LW);
   else if (i==1)
	{
	Add(wierzcholki,LW);
	con(wierzcholki,LW);
	Add(base,LfirstW);
	}
   else{
	con(wierzcholki,LW);
	LfirstW=LW;
	}
  }
  for (int i=0;i<LS;++i)
  {
  	printf("Sciana %d: norm==[%Ld,%Ld,%Ld], trans==[%Ld,%Ld,%Ld]\n",i,sciana[i].norm.x,sciana[i].norm.y,sciana[i].norm.z,sciana[i].trans.x,sciana[i].trans.y,sciana[i].trans.z);
  }
  int LPytan;
  scanf("%d",&LPytan);
  point p;
  while (LPytan--)
  {
	scanf("%Ld%Ld%Ld",&p.x,&p.y,&p.z);
	if (exterior(p))
		printf("NIE\n");
	else
		printf("TAK\n");
  }
// if (LZestaw>0)
	 printf("\n");
 }
 return 0;
}

